# 一、Python 自定义函数的基本步骤 #




## 1、什么是函数 ##

函数，其实我们一开始学 Python 的时候就接触过。

不过我们使用的大多数都是 Python 的内置函数。

比如基本每个章节都会出现的 `print()`  函数。

而现在，我们主要学习的是自定义函数。

**各位有没有想过为什么需要函数呢？**

如果要想回答这个问题，我们需要先了解函数是什么？

函数就是组织好的，可重复使用的，用来实现单一，或相关联功能的代码段。

没错，函数其实就是把代码抽象出来的代码段。

那为什么要抽象出来呢？

**方便我们使用，方便我们重复使用。**

**函数的本质就是我们把一些数据喂给函数，让他内部消化，然后吐出你想要的东西，至于他怎么消化的，我们不需要知道，它内部解决。**

怎么理解这句话呢？

举个例子，好比每次用到的 print 函数，我们都知道这个函数的作用是可以把我们的数据输出到控制台，让我们看到。所以 `print('两点水')` , 我们想打印 `两点水` 出来，就把 `两点水` 这个数据喂给  `print` 函数，然后他就直接把结果打印到控制台上了。







## 2、怎么自定义函数 ##

怎么自定义函数？

要知道怎么定义函数，就要知道函数的组成部分是怎样的。

```python
def 函数名(参数1，参数2....参数n):
    函数体
    return 语句
```

这就是 Python 函数的组成部分。

所以自定义函数，基本有以下规则步骤：

* 函数代码块以 def 关键词开头，后接函数标识符名称和圆括号()
* 任何传入参数和自变量必须放在圆括号中间。圆括号之间可以用于定义参数
* 函数的第一行语句可以选择性地使用文档字符串（用于存放函数说明）
* 函数内容以冒号起始，并且缩进
* return [表达式] 结束函数，选择性地返回一个值给调用方。不带表达式的 return 相当于返回 None。

语法示例：

```python
def functionname( parameters ):
   "函数_文档字符串"
   function_suite
   return [expression]
```

实例：

1. def 定义一个函数，给定一个函数名 sum 
2. 声明两个参数 num1 和 num2
3. 函数的第一行语句进行函数说明：两数之和
4. 最终 return 语句结束函数，并返回两数之和

```python
def sum(num1,num2):
	"两数之和"
	return num1+num2

# 调用函数
print(sum(5,6))
```

输出结果：

```python
11
```










