An Amazing Project
IT 行业相对于一般传统行业，发展更新速度更快，一旦停止了学习，很快就会被行业所淘汰，但是，我们要清楚：淘汰的永远只是那些初级水平的从业者，过硬技术的从业者永远都是稀缺的。因此对于学习，我们还是要踏踏实实的。


自学 Python ，也是一样，不要一开始因为头脑发热就不停地收藏各种资料网站，购买各种书籍，下载了大量的教学视频，过了几天，学习的热情开始褪去，再过几个星期，终于完成了学习课程 —— 《从入门到放弃》。所以，学习 Python 需要一步一个脚印，踏踏实实地学。



# FQ

在讲 Python 如何入门之前，个人建议最好每个人都有自己的 FQ 工具，多使用 Google 搜索，多去看一下墙外的世界，多看 Github 上的开源项目。

至于如何 FQ ，这里提供一下我用过的工具：[FQ工具集](/Res/FQ.md)



# Python 学习资源集

相信很多人学习某门编程语言的时候，都会找各种学习资料。说句实话，资料太多，反而没用，根据自己的学习习惯，个人能力选择一门资源坚持学就好了。

因为每个人的需求不同，这里整理了一批 Python 比较好的学习资料：

* [Python 博客网站资源](/Res/Python博客网站资源.md)

还有一些有趣的网站：

* [一个可以看执行过程的网站](http://www.pythontutor.com/visualize.html#mode=edit)



# Python 入门

对于入门，主要是掌握基本的语法和熟悉编程规范，因此大部分的教程基本一致的，所以还是建议选好适合自己的一个教程，坚持学下去。

在 Python 入门中，本人编写了一系列的 《草根学 Python 》 文章， 是基于 Python 3.6 写的 Python 入门系列教程，为了更好的阅读，把它整理在 [GitBook](https://www.readwithu.com/) 上，希望对各位入门 Python 有所帮助。

>注：2018 年 02 月 27 日，基础知识入门部分已经完成了的。因近期读者反映有些图片没法打开了（之前图片放在七牛云，用的是临时链接，最近七牛云把这个给关闭了，导致图片没法打开），且自己对之前的内容有些不满意，决定在 2019 年 7 月 7 日开始进行了再次修改。但这里做个说明，因为之前写的时候用的是 windows 电脑，现在用 mac ，所以有些例子是 windows 的截图，有些是 mac 的截图，不要觉得奇怪。

**主要目录如下：**

* [为什么学Python?](/Article/PythonBasis/python0/WhyStudyPython.md)
* [Python代码规范](/Article/codeSpecification/codeSpecification_Preface.md)
  - [简明概述](/Article/codeSpecification/codeSpecification_first.md)
  - [注释](/Article/codeSpecification/codeSpecification_second.md)
  - [命名规范](/Article/codeSpecification/codeSpecification_third.md)
* [第一个Python程序](/Article/PythonBasis/python1/Preface.md)
  - [Python 简介](/Article/PythonBasis/python1/Introduction.md)
  - [Python 的安装](/Article/PythonBasis/python1/Installation.md)
  - [第一个 Python 程序](/Article/PythonBasis/python1/The_first_procedure.md)
  - [集成开发环境（IDE）: PyCharm](/Article/PythonBasis/python1/IDE.md)
* [基本数据类型和变量](/Article/PythonBasis/python2/Preface.md)
  - [Python 语法的简要说明](/Article/PythonBasis/python2/Grammar.md)
  - [print() 函数](/Article/PythonBasis/python2/print.md)
  - [Python 的基本数据类型](/Article/PythonBasis/python2/Type_of_data.md)
  - [字符串的编码问题](/Article/PythonBasis/python2/StringCoding.md)
  - [基本数据类型转换](/Article/PythonBasis/python2/Type_conversion.md)
  - [Python 中的变量](/Article/PythonBasis/python2/Variable.md)
* [List 和 Tuple](/Article/PythonBasis/python3/Preface.md)
  - [List（列表）](/Article/PythonBasis/python3/List.md)
  - [tuple（元组）](/Article/PythonBasis/python3/tuple.md)
* [ Dict 和 Set](/Article/PythonBasis/python4/Preface.md)
  - [字典(Dictionary)](/Article/PythonBasis/python4/Dict.md)
  - [set](/Article/PythonBasis/python4/Set.md)
* [条件语句和循环语句](/Article/PythonBasis/python5/Preface.md)
  - [条件语句](/Article/PythonBasis/python5/If.md)
  - [循环语句](/Article/PythonBasis/python5/Cycle.md)
  - [条件语句和循环语句综合实例](/Article/PythonBasis/python5/Example.md)
* [函数](/Article/PythonBasis/python6/Preface.md)
  - [Python 自定义函数的基本步骤](/Article/PythonBasis/python6/1.md)
  - [函数返回值](/Article/PythonBasis/python6/2.md)
  - [函数的参数](/Article/PythonBasis/python6/3.md)
  - [函数传值问题](/Article/PythonBasis/python6/4.md)
  - [匿名函数](/Article/PythonBasis/python6/5.md)
* [迭代器和生成器](/Article/PythonBasis/python7/Preface.md)
  - [迭代](/Article/PythonBasis/python7/1.md)
  - [Python 迭代器](/Article/PythonBasis/python7/2.md)
  - [list 生成式（列表生成式）](/Article/PythonBasis/python7/3.md)
  - [生成器](/Article/PythonBasis/python7/4.md)
  - [迭代器和生成器综合例子](/Article/PythonBasis/python7/5.md)
* [面向对象](/Article/PythonBasis/python8/Preface.md)
  - [面向对象的概念](/Article/PythonBasis/python8/1.md)
  - [类的定义和调用](/Article/PythonBasis/python8/2.md)
  - [类方法](/Article/PythonBasis/python8/3.md)
  - [修改和增加类属性](/Article/PythonBasis/python8/4.md)
  - [类和对象](/Article/PythonBasis/python8/5.md)
  - [初始化函数](/Article/PythonBasis/python8/6.md)
  - [类的继承](/Article/PythonBasis/python8/7.md)
  - [类的多态](/Article/PythonBasis/python8/8.md)
  - [类的访问控制](/Article/PythonBasis/python8/9.md)
* [模块与包](/Article/PythonBasis/python9/Preface.md)
  - [Python 模块简介](/Article/PythonBasis/python9/1.md)
  - [模块的使用](/Article/PythonBasis/python9/2.md)
  - [主模块和非主模块](/Article/PythonBasis/python9/3.md)
  - [包](/Article/PythonBasis/python9/4.md)
  - [作用域](/Article/PythonBasis/python9/5.md)
* [Python 的 Magic Method](/Article/PythonBasis/python10/Preface.md)
  - [Python 的 Magic Method](/Article/PythonBasis/python10/1.md)
  - [构造(`__new__`)和初始化(`__init__`)](/Article/PythonBasis/python10/2.md)
  - [属性的访问控制](/Article/PythonBasis/python10/3.md)
  - [对象的描述器](/Article/PythonBasis/python10/4.md)
  - [自定义容器（Container）](/Article/PythonBasis/python10/5.md)
  - [运算符相关的魔术方法](/Article/PythonBasis/python10/6.md)
* [枚举类](/Article/python11/PythonBasis/Preface.md)
  - [枚举类的使用](/Article/PythonBasis/python11/1.md)
  - [Enum 的源码](/Article/PythonBasis/python11/2.md)
  - [自定义类型的枚举](/Article/PythonBasis/python11/3.md)
  - [枚举的比较](/Article/PythonBasis/python11/4.md)
* [元类](/Article/PythonBasis/python12/Preface.md)
  - [Python 中类也是对象](/Article/PythonBasis/python12/1.md)
  - [使用 `type()` 动态创建类](/Article/PythonBasis/python12/2.md)
  - [什么是元类](/Article/PythonBasis/python12/3.md)
  - [自定义元类](/Article/PythonBasis/python12/4.md)
  - [使用元类](/Article/PythonBasis/python12/5.md)
* [线程与进程](/Article/PythonBasis/python13/Preface.md)
  - [线程与进程](/Article/PythonBasis/python13/1.md)
  - [多线程编程](/Article/PythonBasis/python13/2.md)
  - [进程](/Article/PythonBasis/python13/3.md)
* [一步一步了解正则表达式](/Article/PythonBasis/python14/Preface.md)
    - [初识 Python 正则表达式](/Article/PythonBasis/python14/1.md)
    - [字符集](/Article/PythonBasis/python14/2.md)
    - [数量词](/Article/PythonBasis/python14/3.md)
    - [边界匹配符和组](/Article/PythonBasis/python14/4.md)
    - [re.sub](/Article/PythonBasis/python14/5.md)
    - [re.match 和 re.search](/Article/PythonBasis/python14/6.md)
* [闭包](/Article/PythonBasis/python15/1.md)
* [装饰器](/Article/PythonBasis/python16/1.md)




# 知识点补漏
* [Python 关键字 yield](/Article/supplement/Python关键字yield.md)



# Python 进阶

* [使用Python虚拟环境](/Article/advanced/使用Python虚拟环境.md)
* [Mac中使用virtualenv和virtualenvwrapper](/Article/advanced/Mac中使用virtualenv和virtualenvwrapper.md)




# HTML 和 CSS 入门


# JavaScript 入门



# Django

Python 下有许多款不同的 Web 框架。Django 是重量级选手中最有代表性的一位。许多成功的网站和 APP 都基于 Django。

如果对自己的基础有点信息的童鞋，可以尝试通过国外的 [Django 博客从搭建到部署系列教程](https://simpleisbetterthancomplex.com/series/2017/09/04/a-complete-beginners-guide-to-django-part-1.html) 进行入门，这个教程讲的非常的详细，而且还有很多有趣的配图。不过可能因为墙的原因，很多人会访问不到，就算访问到了，也因为是英语的，不会进行耐心的阅读学习。因此我打算翻译这个教程。

* [一个完整的初学者指南Django-part1](/Article/django/一个完整的初学者指南Django-part1.md)
* [一个完整的初学者指南Django-part2](/Article/django/一个完整的初学者指南Django-part2.md)


持续更新....


可以关注我的公众号，实时了解更新情况。

<img src="http://twowaterimage.oss-cn-beijing.aliyuncs.com/2020-09-15-121312.jpg" width="50%" height="50%">




